package petruchio.common.rationals;

import java.math.BigInteger;

public interface Rational<T> extends Comparable<Rational<T>> {
    
    public Rational<T> add(final Rational<T> summand);
    
    public Rational<T> subtract(final Rational<T> subtrahend);
    
    public Rational<T> multiply(final Rational<T> factor);
    
    public Rational<T> divide(final Rational<T> divisor);
    
    public Rational<T> add(final BigInteger summand);
    
    public Rational<T> subtract(final BigInteger subtrahend);
    
    public Rational<T> multiply(final BigInteger factor);
    
    public Rational<T> divide(final BigInteger divisor);
    
    public Rational<T> add(final int summand);
    
    public Rational<T> subtract(final int subtrahend);
    
    public Rational<T> multiply(final int factor);
    
    public Rational<T> divide(final int divisor);
    
    public Rational<T> negate();
    
    public BigInteger numerator();
    
    public BigInteger denominator();
    
    public Rational<T> ceil();
    public Rational<T> floor();
    
    public int signum();
    
    public int compareTo(final int value);
    
    public boolean isZero();
    public boolean isPositive();
    public boolean isNegative();
    public boolean isNonPositive();
    public boolean isNonNegative();
    
    public int    intValue();
    public long   longValue();
    public float  floatValue();
    public double doubleValue();
    
}
