/*
 * Project: Petruchio
 * File:    LexProcessComparator.java
 * Author:  Tim Strazny
 * Created: 03.11.2008
 */
package petruchio.compiler;

import java.util.Comparator;

import petruchio.interfaces.pi.Process;

/**
 * @author Tim Strazny
 */
public enum LexProcessComparator implements Comparator<Process<?>> {
    COMPARATOR;
    
    /**
     * @return
     */
    public static LexProcessComparator getInstance() {
        return LexProcessComparator.COMPARATOR;
    }

    /* (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    @Override
    public int compare(final Process<?> o1, final Process<?> o2) {
        String s1 = o1.toString();
        String s2 = o2.toString();
        
        char c1;
        int i1 = -1;
        do {
            ++i1;
            c1 = s1.charAt(i1);    
        } while(c1 == '(' || Character.isWhitespace(c1));
        
        char c2;
        int i2 = -1;
        do {
            ++i2;
            c2 = s2.charAt(i2);    
        } while(c2 == '(' || Character.isWhitespace(c2));
        
        int n1=s1.length(), n2=s2.length();
        for (; i1<n1 && i2<n2; i1++, i2++) {
            c1 = s1.charAt(i1);
            c2 = s2.charAt(i2);
            if (c1 != c2) {
                c1 = Character.toUpperCase(c1);
                c2 = Character.toUpperCase(c2);
                if (c1 != c2) {
                    c1 = Character.toLowerCase(c1);
                    c2 = Character.toLowerCase(c2);
                    if (c1 != c2) {
                        return c1 - c2;
                    }
                }
            }
        }
        return n1 - n2;
    }

}
