/*
 * File:    Point.java
 * Project: petruchio
 * Author:  Tim Strazny
 * Created: 31.05.2009
 */
package petruchio.compiler;

/**
 * @author Tim Strazny
 */
public class Point {
    private int x;
    private int y;
    
    public Point(final int x, final int y) {
        this.x = x;
        this.y = y;
    }
    
    public int getX() {
        return this.x;
    }
    
    public int getY() {
        return this.y;
    }
    
    public void setX(final int x) {
        this.x = x;
    }
    
    public void setY(final int y) {
        this.y = y;
    }
    
    public void setLocation(final int x, final int y) {
        this.x = x;
        this.y = y;
    }
    
    @Override
    public int hashCode() {
        return 31*(31*29 + this.x) + this.y;
    }
    
    @Override
    public boolean equals(final Object o) {
        return (o instanceof Point) && this.equals((Point)o);
    }
    
    public boolean equals(final Point p) {
        return this.x == p.x && this.y == p.y;
    }
}
