/*
 * Project:  Petruchio
 * Filename: ProcessComparator.java
 * Created:  29.01.2007
 * Author:   Tim Strazny
 */
package petruchio.compiler;

import java.util.Comparator;

import petruchio.interfaces.pi.Process;

/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class ProcessComparator implements Comparator<Process<ProcessData>> {
    
    /**
     * 
     */
    private static final ProcessComparator COMPARATOR = new ProcessComparator();
    
    
    /**
     * TODO: document
     *
     * @return
     */
    public static ProcessComparator getInstance() {
        return ProcessComparator.COMPARATOR;
    }
    

    /* (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    @Override
    public int compare(final Process<ProcessData> p1, final Process<ProcessData> p2) {
        // if(true) return 0; // deactivate process ordering.
        final ProcessData p1d = CommonTasks.getData(p1);
        final ProcessData p2d = CommonTasks.getData(p2);
        
//        boolean w = p2.toString().equals("1EIN(ein, reqlagerhtf)");
        
        if(p1d.getFn().size() < p2d.getFn().size()) {
//            if(w) System.out.println("fn: " + p1d.getFn().size() + " < " + p2d.getFn().size());
//            System.out.println("a");
            return -1;
        } else if(p1d.getFn().size() != p2d.getFn().size()) {
//            System.out.println("b");
            return 1;
        }
        
        if(p1d.getNewCount() < p2d.getNewCount()) {
//            if(w) System.out.println("new: " + p1d.getNewCount() + " < " + p2d.getNewCount());
//            System.out.println("c");
            return -1;
        } else if(p1d.getNewCount() != p2d.getNewCount()) {
//            System.out.println("d");
            return 1;
        }
        
        if(p1d.getInParamCount() < p2d.getInParamCount()) {
//            if(w) System.out.println("inP: " + p1d.getInParamCount() + " < " + p2d.getInParamCount());
//            System.out.println("e");
            return -1;
        } else if(p1d.getInParamCount() != p2d.getInParamCount()) {
//            System.out.println("f");
            return 1;
        }
        
        if(p1d.getOutParamCount() < p2d.getOutParamCount()) {
//          if(w) System.out.println("outP: " + p1d.getOutParamCount() + " < " + p2d.getOutParamCount());
//            System.out.println("g");
            return -1;
        } else if(p1d.getOutParamCount() != p2d.getOutParamCount()) {
//            System.out.println("h");
            return 1;
        }
        
        if(p1d.getInCount() < p2d.getInCount()) {
//            if(w) System.out.println("in: " + p1d.getInCount() + " < " + p2d.getInCount());
//            System.out.println("i"); 
            return -1;
        } else if(p1d.getInCount() != p2d.getInCount()) {
//            System.out.println("j");
            return 1;
        }
        
        if(p1d.getOutCount() < p2d.getOutCount()) {
//            if(w) System.out.println("out: " + p1d.getOutCount() + " < " + p2d.getOutCount());
//            System.out.println("k");
            return -1;
        } else if(p1d.getOutCount() != p2d.getOutCount()) {
//            System.out.println("l");
            return 1;
        }
        
        if(p1d.getTauCount() < p2d.getTauCount()) {
//            if(w) System.out.println("tau: " + p1d.getTauCount() + " < " + p2d.getTauCount());
//            System.out.println("m");
            return -1;
        } else if(p1d.getTauCount() != p2d.getTauCount()) {
//            System.out.println("n");
            return 1;
        }
        
        if(p1d.getGuardCount() < p2d.getGuardCount()) {
//            if(w) System.out.println("guard: " + p1d.getGuardCount() + " < " + p2d.getGuardCount());
//            System.out.println("o");
            return -1;
        } else if(p1d.getGuardCount() != p2d.getGuardCount()) {
//            System.out.println("p");
            return 1;
        }
        
        if(p1d.getNullProcCount() < p2d.getNullProcCount()) {
//            if(w) System.out.println("null: " + p1d.getNullProcCount() + " < " + p2d.getNullProcCount());
//            System.out.println("q");
            return -1;
        } else if(p1d.getNullProcCount() != p2d.getNullProcCount()) {
//            System.out.println("r");
            return 1;
        }
        
        if(p1d.getRefProcCount() < p2d.getRefProcCount()) {
//            if(w) System.out.println("ref: " + p1d.getRefProcCount() + " < " + p2d.getRefProcCount());
//            System.out.println("s");
            return -1;
        } else if(p1d.getRefProcCount() != p2d.getRefProcCount()) {
//            System.out.println("t");
            return 1;
        }
        
        final int a = p1d.getProcessAbstraction().compareTo(p2d.getProcessAbstraction());
        if(a != 0) {
//            System.out.println("u");
            return a;
        }
        
//        System.out.println("v");
        return CommonTasks.compareNameList(p1d.getFn(), p2d.getFn());
    }
    
}
