package petruchio.compiler;

import java.util.Comparator;

import petruchio.interfaces.pi.Process;

public class ProcessComparatorNoFN implements Comparator<Process<ProcessData>> {

    /**
     * 
     */
    private static final ProcessComparatorNoFN COMPARATOR = new ProcessComparatorNoFN();
    
    
    /**
     * TODO: document
     *
     * @return
     */
    public static ProcessComparatorNoFN getInstance() {
        return ProcessComparatorNoFN.COMPARATOR;
    }
    

    /* (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    @Override
    public int compare(final Process<ProcessData> p1, final Process<ProcessData> p2) {
        // if(true) return 0; // deactivate process ordering.
        final ProcessData p1d = CommonTasks.getData(p1);
        final ProcessData p2d = CommonTasks.getData(p2);
        
        if(p1d.getNewCount() < p2d.getNewCount()) {
//            System.out.println("c");
            return -1;
        } else if(p1d.getNewCount() != p2d.getNewCount()) {
//            System.out.println("d");
            return 1;
        }
        
        if(p1d.getInParamCount() < p2d.getInParamCount()) {
//            System.out.println("e");
            return -1;
        } else if(p1d.getInParamCount() != p2d.getInParamCount()) {
//            System.out.println("f");
            return 1;
        }
        
        if(p1d.getOutParamCount() < p2d.getOutParamCount()) {
//            System.out.println("g");
            return -1;
        } else if(p1d.getOutParamCount() != p2d.getOutParamCount()) {
//            System.out.println("h");
            return 1;
        }
        
        if(p1d.getInCount() < p2d.getInCount()) {
//            System.out.println("i"); 
            return -1;
        } else if(p1d.getInCount() != p2d.getInCount()) {
//            System.out.println("j");
            return 1;
        }
        
        if(p1d.getOutCount() < p2d.getOutCount()) {
//            System.out.println("k");
            return -1;
        } else if(p1d.getOutCount() != p2d.getOutCount()) {
//            System.out.println("l");
            return 1;
        }
        
        if(p1d.getTauCount() < p2d.getTauCount()) {
//            System.out.println("m");
            return -1;
        } else if(p1d.getTauCount() != p2d.getTauCount()) {
//            System.out.println("n");
            return 1;
        }
        
        if(p1d.getGuardCount() < p2d.getGuardCount()) {
//            System.out.println("o");
            return -1;
        } else if(p1d.getGuardCount() != p2d.getGuardCount()) {
//            System.out.println("p");
            return 1;
        }
        
        if(p1d.getNullProcCount() < p2d.getNullProcCount()) {
//            System.out.println("q");
            return -1;
        } else if(p1d.getNullProcCount() != p2d.getNullProcCount()) {
//            System.out.println("r");
            return 1;
        }
        
        if(p1d.getRefProcCount() < p2d.getRefProcCount()) {
//            System.out.println("s");
            return -1;
        } else if(p1d.getRefProcCount() != p2d.getRefProcCount()) {
//            System.out.println("t");
            return 1;
        }
        
//        System.out.println("u");
        return p1d.getProcessAbstraction().compareTo(p2d.getProcessAbstraction());
    }

}
