/*
 * Project:  Petruchio
 * Filename: CommunicationReaction.java
 * Created:  16.12.2006
 * Author:   Tim Strazny
 */
package petruchio.compiler.reactions;

import java.util.Iterator;
import java.util.List;

import petruchio.interfaces.pi.Name;


/**
 * <Description>
 * 
 * @param <E>
 * @author Tim Strazny
 */
public class CommunicationReaction<E> extends Reaction<E> implements
                petruchio.interfaces.algorithms.CommunicationReaction<E> {

    /**
     * 
     */
    private Name channel;
    
    /**
     * 
     */
    private List<Name> namesBefore;
    
    /**
     * 
     */
    private List<Name> namesAfter;
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.algorithms.Reaction#getType()
     */
    @Override
    public petruchio.interfaces.algorithms.Reaction.Type getType() {
        return petruchio.interfaces.algorithms.Reaction.Type.COMMUNICATION;
    }
    

    /* (non-Javadoc)
     * @see petruchio.interfaces.algorithms.CommunicationReaction#getChannel()
     */
    @Override
    public Name getChannel() {
        return this.channel;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.algorithms.CommunicationReaction#getNamesAfter()
     */
    @Override
    public List<Name> getNamesAfter() {
        return this.namesAfter;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.algorithms.CommunicationReaction#getNamesBefore()
     */
    @Override
    public List<Name> getNamesBefore() {
        return this.namesBefore;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.algorithms.CommunicationReaction#setChannel(java.lang.String)
     */
    @Override
    public void setChannel(final Name channel) {
        this.channel = channel;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.algorithms.CommunicationReaction#setNamesAfter(java.util.List)
     */
    @Override
    public void setNamesAfter(final List<Name> names) {
        this.namesAfter = names;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.algorithms.CommunicationReaction#setNameBefore(java.util.List)
     */
    @Override
    public void setNamesBefore(final List<Name> names) {
        this.namesBefore = names;
    }

    
    /* (non-Javadoc)
     * @see petruchio.compiler.reaction.Reaction#toString()
     */
    @Override
    public String toString() {
        final StringBuilder b = new StringBuilder();
        b.append(this.getChannel());
        b.append("<");
        for(final Iterator<Name> it = this.getNamesAfter().iterator(); it.hasNext();) {
            b.append(it.next());
            if(it.hasNext()) {
                b.append(",");
            }
        }
        b.append(">|");
        b.append(this.getChannel());
        b.append("(");
        for(final Iterator<Name> it = this.getNamesBefore().iterator(); it.hasNext();) {
            b.append(it.next());
            if(it.hasNext()) {
                b.append(",");
            }
        }
        b.append(")");
        return b.toString();
    }
}
