/*
 * Project:  Petruchio
 * Filename: PlaceComparator.java
 * Created:  18.02.2007
 * Author:   Tim Strazny
 */
package petruchio.cov;

import java.util.Comparator;

import petruchio.interfaces.petrinet.Place;

/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class PlaceComparator implements Comparator<Place> {
    
    /**
     * 
     */
    private static final PlaceComparator COMPARATOR = new PlaceComparator();
    
    
    /**
     * TODO: document
     *
     * @return
     */
    public static PlaceComparator getInstance() {
        return PlaceComparator.COMPARATOR;
    }
    

    /**
     * 
     */
    private PlaceComparator() {
        // private
    }
    
    
    /* (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    @Override
    public int compare(final Place o1, final Place o2) {
        final int o1i = System.identityHashCode(o1);
        final int o2i = System.identityHashCode(o2);
        if(o1i == o2i) {
            return 0;
        } else if(o1i < o2i) {
            return -1;
        } else {
            return 1;
        }
    }
    
    
    /**
     * TODO: document
     *
     * @param o1
     * @param o2
     * @return
     */
    public boolean isLess(final Place o1, final Place o2) {
        return System.identityHashCode(o1) < System.identityHashCode(o2);
    }

}