/*
 * Project:  Petruchio
 * Filename: PlacePair.java
 * Created:  19.02.2007
 * Author:   Tim Strazny
 */
package petruchio.cov;

import petruchio.interfaces.petrinet.Place;


/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class PlacePair implements petruchio.interfaces.petrinet.PlacePair {

    /** */
    private Place p1;

    /** */
    private Place p2;
    
    
    /**
     * @param p1
     * @param p2
     */
    public PlacePair(final Place p1, final Place p2) {
        this.p1 = p1;
        this.p2 = p2;
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(final Object o) {
        return (o instanceof PlacePair) && this.equals((PlacePair)o);
    }
    
    /**
     * @param o
     * @return
     */
    public boolean equals(final PlacePair o) {
        return (((this.p1 == o.p1) && (this.p2 == o.p2)) || ((this.p1 == o.p2) && (this.p2 == o.p1)));
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        return System.identityHashCode(this.p1) ^ System.identityHashCode(this.p2);
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PlacePair#getPlaceA()
     */
    @Override
    public Place getPlaceA() {
        return this.p1;
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PlacePair#getPlaceB()
     */
    @Override
    public Place getPlaceB() {
        return this.p2;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PlacePair#setPlaceA(petruchio.interfaces.petrinet.Place)
     */
    @Override
    public void setPlaceA(final Place a) {
        this.p1 = a;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PlacePair#setPlaceB(petruchio.interfaces.petrinet.Place)
     */
    @Override
    public void setPlaceB(final Place b) {
        this.p2 = b;
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "(" + this.p1 + ", " + this.p2 + ")";
    }
}