/*
 * Project:  Petruchio
 * Filename: PetriNetReductorIgnorerInput.java
 * Created:  25.09.2007
 * Author:   Tim Strazny
 */
package petruchio.interfaces.petrinet;

import java.io.InputStream;

import petruchio.interfaces.Resettable;

/**
 * A class implementing this interface opens an InputStream object for some kind
 * of resource that can be passed to a
 * {@link petruchio.interfaces.petrinet.PetriNetReductorIgnorer} object.
 *
 * @author Tim Strazny
 */
public interface PetriNetReductorIgnorerInput extends Resettable {

	/**
	 * Opens an InputStream to the given resource.
	 *
	 * @param value The resource.
	 * @return An InputStream to read the resource.
	 */
	public InputStream getInput(String value);
	
}