/*
 * Project:  Petruchio
 * Filename: PlacePair.java
 * Created:  24.04.2007
 * Author:   Tim Strazny
 */
package petruchio.interfaces.petrinet;


/**
 * A pair of places.
 * 
 * @author Tim Strazny
 */
public interface PlacePair {

    
    /**
     * Returns the first place of this pair.
     *
     * @return The first place of this pair
     */
    public Place getPlaceA();
    
    
    /**
     * Returns the second place of this pair.
     *
     * @return The second place of this pair
     */
    public Place getPlaceB();
    
    
    /**
     * Sets the first place of this pair.
     * 
     * @param a The first place of this pair
     */
    public void setPlaceA(Place a);
    
    
    /**
     * Sets the second place of this pair.
     *
     * @param b The second place of this pair
     */
    public void setPlaceB(Place b);
    
}