/*
 * Project:  Petruchio
 * Filename: TPArc.java
 * Created:  02.08.2007
 * Author:   Tim Strazny
 */
package petruchio.interfaces.petrinet;


/**
 * A Petri net arc from a transition to a place.
 * 
 * @author Tim Strazny
 */
public interface TPArc {
    
    /**
     * Returns the transition that is the source of this arc.
     *
     * @return The transition that is the source of this arc.
     */
    public Transition getSource();
    
    
    /**
     * Returns the place that is the target of this arc.
     *
     * @return The place that is the target of this arc.
     */
    public Place getTarget();
    
    
    /**
     * Returns the weight of this arc.
     * 
     * @return This arc's weight
     */
    public int getWeight();
    
    
    /**
     * Sets the weight of this arc.
     *
     * @param weight The new weight.
     */
    public void setWeight(int weight);
    
}