/*
 * Project:  Petruchio
 * Filename: TransferArc.java
 * Created:  18.03.2010
 * Author:   Tim Strazny
 */
package petruchio.interfaces.petrinet;

import java.util.Collection;
import java.util.Map;

/**
 * A transfer arc.
 * 
 * @author Tim Strazny
 */
public interface TransferArc extends TPArc {

    /**
     * The inscription of the arc containing places and their multipliers.
     * 
     * @return A mapping from places to multipliers.
     */
    public Map<Place, Integer> getTransfer();
    
    
    /**
     * 
     * @param p The read place.
     * @param m The multiplier.
     */
    public void setMultiplier(Place p, int m);
    
    /**
     * 
     * @param p
     * @return
     */
    public int getMultiplier(Place p);
    
    /**
     * @param m
     */
    public void setMultipliers(Map<Place, Integer> m);
    
    /**
     * @param p
     * @param m
     */
    public void addMultiplier(Place p, int m);
    
    /**
     * @param m
     */
    public void removeMultipliers(Collection<Place> p);
    
    /**
     * @param p
     */
    public void removeMultiplier(Place p);
    
    /**
     * @return
     */
    public int getBound();
    
    
    /**
     * @param bound
     */
    public void setBound(int bound);
    
    
}
