/*
 * Project:  Petruchio
 * Filename: InputAction.java
 * Created:  05.12.2006
 * Author:   Tim Strazny
 */
package petruchio.interfaces.pi;


/**
 * A pi calculus input action. in a(b, c)
 * 
 * @author Tim Strazny
 */
public interface InputAction extends ActionPrefix {
    
    /**
     * Returns the channel name which is used.
     *
     * @return The channel name which is used.
     */
    public Name getChannel();
    
    
    /**
     * Returns the names that are received and bound by this action. 
     *
     * @return The names that are received and bound by this action.
     */
    public Parameters getNames();
    
}