/*
 * Project:  Petruchio
 * Filename: OutputAction.java
 * Created:  05.12.2006
 * Author:   Tim Strazny
 */
package petruchio.interfaces.pi;


/**
 * A pi calculus output action. out a<b, c>
 * 
 * @author Tim Strazny
 */
public interface OutputAction extends ActionPrefix {

    /**
     * Returns the channel name which is used.
     *
     * @return The channel name which is used.
     */
    public Name getChannel();
    
    
    /**
     * Returns the names that are sent by this action.
     *
     * @return The names that are sent by this action.
     */
    public Parameters getNames();
    
}