/*
 * Project:  Petruchio
 * Filename: PrefixProcess.java
 * Created:  19.01.2007
 * Author:   Tim Strazny
 */
package petruchio.interfaces.pi;


/**
 * A pi calculus process that has more action prefixes and restrictions.
 * With this class a pi calculus process may have action prefixes before
 * restrictions.
 * 
 * @param <E> The data type of the process.
 * @author Tim Strazny
 */
public interface PrefixProcess<E> extends Process<E> {
    
    /**
     * Returns the sub process.
     *
     * @return The sub process
     */
    public Process<E> getProcess();
    
}