/*
 * Project:  Petruchio
 * Filename: ProcessReference.java
 * Created:  09.12.2006
 * Author:   Tim Strazny
 */
package petruchio.interfaces.pi;


/**
 * A pi calculus process reference.
 * 
 * @param <E> The data type of the process.
 * @author Tim Strazny
 */
public interface ProcessReference<E> extends Process<E> {

    /**
     * Returns the identifier of the referenced process.
     *
     * @return The identifier of the referenced process
     */
    public ProcessID getProcessID();
    
    
    /**
     * Returns the value parameters of the process reference.
     *
     * @return the parameters of this process reference
     */
    public Parameters getParameters();
    
}