/*
 * Project:  Petruchio
 * Filename: Guard.java
 * Created:  05.12.2006
 * Author:   Tim Strazny
 */
package petruchio.pi;

import petruchio.interfaces.pi.ActionPrefix;
import petruchio.interfaces.pi.Name;


/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class Guard implements petruchio.interfaces.pi.Guard {

    /**
     * 
     */
    private final Name left;
    
    /**
     * 
     */
    private final Name right;
    
    private final boolean isSatisfied;
    
    private int h = 0;
    
    
    /**
     * @param left
     * @param op
     * @param right
     */
    public Guard(final Name left, final Name right) {
        this.left = left;
        this.right = right;
        this.isSatisfied = left.equals(right);
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.ActionPrefix#getType()
     */
    @Override
    public ActionPrefix.Type getType(){
        return ActionPrefix.Type.GUARD;
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Guard#leftOperand()
     */
    @Override
    public Name leftOperand() {
        return this.left;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Guard#rightOperand()
     */
    @Override
    public Name rightOperand() {
        return this.right;
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Guard#isSatisfied()
     */
    @Override
    public boolean isSatisfied() {
        return this.isSatisfied;
    }

    
    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        if(this.h == 0) {
            this.h = this.left.hashCode() ^ this.right.hashCode();
        }
        return this.h;
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(final Object o) {
        return (o instanceof Guard) && this.equals((Guard)o);
    }
    
    
    /**
     * @param o
     * @return
     */
    public boolean equals(final Guard o) {
        return (o != null)
                && ((this.left.equals(o.leftOperand()) && this.right.equals(o.rightOperand()))
                   || (this.left.equals(o.rightOperand()) && this.right.equals(o.leftOperand())));
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "[" + this.left + "=" + this.right + "]"; 
    }

}
