/*
 * Project:  Petruchio
 * Filename: OutputAction.java
 * Created:  05.12.2006
 * Author:   Tim Strazny
 */
package petruchio.pi;


import petruchio.interfaces.pi.ActionPrefix;
import petruchio.interfaces.pi.Name;
import petruchio.interfaces.pi.Parameters;

/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class OutputAction implements petruchio.interfaces.pi.OutputAction {

    /**
     * 
     */
    private final Name channel;
    
    /**
     * 
     */
    private final Parameters names;
    
    private int h = 0;
    
    
    
    /**
     * @param channel
     * @param names
     */
    public OutputAction(final Name channel, final Parameters names) {
        this.channel = channel;
        this.names = names;
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        if(this.h == 0) {
            this.h = this.channel.hashCode() ^ this.names.hashCode();
        }
        return this.h;
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(final Object o) {
        return (o instanceof OutputAction) && this.equals((OutputAction)o);
    }
    
    
    /**
     * @param o
     * @return
     */
    public boolean equals(final OutputAction o) {
        return (o != null) && this.channel.equals(o.getChannel())
                && this.names.equals(o.getNames());
    }

    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.ActionPrefix#getType()
     */
    @Override
    public ActionPrefix.Type getType(){
        return ActionPrefix.Type.OUTPUT;
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.OutputAction#getChannel()
     */
    @Override
    public Name getChannel() {
        return this.channel;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.OutputAction#getNames()
     */
    @Override
    public Parameters getNames() {
        return this.names;
    }

    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        final StringBuilder b = new StringBuilder();
        b.append(this.channel);
        b.append("<");
        if(!this.names.isEmpty()) {
            b.append(this.names);
        }
        b.append(">");
        return b.toString();
    }

}