/*
 * Project:  Petruchio
 * Filename: Parameters.java
 * Created:  05.12.2006
 * Author:   Tim Strazny
 */
package petruchio.pi;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import petruchio.interfaces.pi.Name;


/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class Parameters implements petruchio.interfaces.pi.Parameters {

    /**
     * 
     */
    private final List<Name> params;
    
    
    /**
     * 
     */
    public Parameters() {
        this.params = new ArrayList<Name>(0);
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Parameters#add(java.lang.String)
     */
    @Override
    public void add(final Name param) {
        this.params.add(param);
    }

    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Parameters#getParameters()
     */
    @Override
    public List<Name> getParameters(){
        return this.params;
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Parameters#isEmpty()
     */
    @Override
    public boolean isEmpty() {
        return this.params.isEmpty();
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Parameters#size()
     */
    @Override
    public int size() {
        return this.params.size();
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        if(this.isEmpty()) {
            return "";
        }
        final StringBuilder b = new StringBuilder();
        for(final Iterator<Name> it = this.params.iterator(); it.hasNext();) {
            b.append(it.next());
            if(it.hasNext()) {
                b.append(", ");
            }
        }
        return b.toString();
    }

}