/*
 * Project:  Petruchio
 * Filename: PrefixProcess.java
 * Created:  19.01.2007
 * Author:   Tim Strazny
 */
package petruchio.pi;

import petruchio.interfaces.pi.Process;


/**
 * <Description>
 * 
 * @param <E>
 * @author Tim Strazny
 */
public class PrefixProcess<E> extends petruchio.pi.Process<E> implements petruchio.interfaces.pi.PrefixProcess<E> {

    /**
     * 
     */
    private Process<E> process = null;
    
    
    /**
     * @param p
     */
    public PrefixProcess(final Process<E> p) {
        this.process = p;
    }
    

    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.Process#getType()
     */
    @Override
    public petruchio.interfaces.pi.Process.Type getType() {
        return petruchio.interfaces.pi.Process.Type.PREFIX;
    }
    
    
    /* (non-Javadoc)
     * @see petruchio.pi.Process#getSuffix()
     */
    @Override
    public String getSuffix() {
        return (this.process != null) ? this.process.toString() : "null";
    }

    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.PrefixProcess#getProcess()
     */
    @Override
    public Process<E> getProcess() {
        return this.process;
    }

}