/*
 * Project:  Petruchio
 * Filename: ProcessID.java
 * Created:  01.12.2006
 * Author:   Tim Strazny
 */
package petruchio.pi;


import petruchio.interfaces.pi.Name;

/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class ProcessID implements petruchio.interfaces.pi.ProcessID {

    /**
     * 
     */
    private final Name id;
    
    
    /**
     * @param id
     */
    public ProcessID(final Name id) {
        this.id = id;
    }

    
    /* (non-Javadoc)
     * @see petruchio.interfaces.pi.ProcessID#getID()
     */
    @Override
    public Name getID() {
        return this.id;
    }

    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(final Object o) {
        return (o instanceof ProcessID) && this.equals((ProcessID)o);
    }
    
    
    /**
     * TODO: document
     *
     * @param pid
     * @return
     */
    public boolean equals(final ProcessID pid) {
        return pid.id.equals(this.id);
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        return this.id.hashCode();
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return this.getID().toString();
    }


    /* (non-Javadoc)
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    @Override
    public int compareTo(petruchio.interfaces.pi.ProcessID pid) {
        return this.id.compareTo(pid.getID());
    }
}