/*
 * Project:  Petruchio
 * Filename: PiSymbol.java
 * Created:  13.08.2007
 * Author:   Tim Strazny
 */
package petruchio.pi.readers.cup;


import java_cup.runtime.ComplexSymbolFactory.ComplexSymbol;
import java_cup.runtime.ComplexSymbolFactory.Location;

/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class PiSymbol extends ComplexSymbol {

    private int line;

    private int column;


    /**
     * @param type
     * @param line
     * @param column
     * @param value
     */
    public PiSymbol(int type, int line, int column, Object value) {
        this(type, line, column, value instanceof String ? ((String)value).length() : 0, value);
    }


    public PiSymbol(int type, int line, int column, int length,
                    Object value) {
        super("", type, new Location(line, column), new Location(line, column + length), value);
        this.line = line;
        this.column = column;
    }


    /**
     * TODO: document
     *
     * @return
     */
    public int getLine() {
        return this.line;
    }


    /**
     * TODO: document
     *
     * @return
     */
    public int getColumn() {
        return this.column;
    }


    /* (non-Javadoc)
     * @see java_cup.runtime.Symbol#toString()
     */
    @Override
    public String toString() {
        return "line " + this.line + ", column " + this.column + ", sym: " + this.sym
                + (this.value == null ? "" : (", value: '" + this.value + "'"));
    }
}