/*
 * Project:  Petruchio
 * Filename: StringInput.java
 * Created:  25.09.2007
 * Author:   Tim Strazny
 */
package petruchio.pn.rdiginput;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import petruchio.interfaces.SelfDescribing;
import petruchio.interfaces.petrinet.PetriNetReductorIgnorerInput;

/**
 * TODO: description 
 *
 * @author Tim Strazny
 */
public class StringInput implements SelfDescribing, PetriNetReductorIgnorerInput {

    /* (non-Javadoc)
     * @see petruchio.interfaces.SelfDescribing#getDescription()
     */
    @Override
    public String getDescription() {
        return "Interprets the given PetriNetReductorIgnorerInput to be a String literal.";
    }
    
    
	/* (non-Javadoc)
	 * @see petruchio.interfaces.Resettable#reset()
	 */
	@Override
    public void reset() {
		// no caches
	}
	
	
	/* (non-Javadoc)
	 * @see petruchio.interfaces.petrinet.PetriNetReductorIgnorerInput#getInput(java.lang.String)
	 */
	@Override
    public InputStream getInput(final String value) {
		if(value == null) {
			return null;
		}
		return new ByteArrayInputStream(value.getBytes());
	}

}