/*
 * Project: Petruchio
 * File:    PrintSize.java
 * Author:  Tim Strazny
 * Created: 02.01.2008
 */
package petruchio.pn.reductors;

import java.util.Collection;

import petruchio.interfaces.petrinet.PetriNet;
import petruchio.interfaces.petrinet.PetriNetReductor;
import petruchio.interfaces.petrinet.Place;
import petruchio.interfaces.petrinet.Transition;


/**
 * TODO: Document
 * 
 * @author Tim Strazny
 */
public class PrintSize implements PetriNetReductor {

    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PetriNetReductor#getDescription()
     */
    @Override
    public String getDescription() {
        return "Prints the size of the Petri net to stdout.";
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PetriNetReductor#getName()
     */
    @Override
    public String getName() {
        return "print size";
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PetriNetReductor#reduce(petruchio.interfaces.petrinet.PetriNet)
     */
    @Override
    public int reduce(PetriNet net) {
        System.out.println("Petri net size: " + net.getPlaces().size() + " P, " + net.getTransitions().size()
              + " T, " + net.getPTArcCount() + " PT, " + net.getTPArcCount() + " TP");
        return 0;
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.petrinet.PetriNetReductor#reduce(petruchio.interfaces.petrinet.PetriNet, java.util.Collection, java.util.Collection)
     */
    @Override
    public int reduce(PetriNet net, Collection<Place> ignorePlaces,
            Collection<Transition> ignoreTransitions) {
        return this.reduce(net);
    }


    /* (non-Javadoc)
     * @see petruchio.interfaces.Resettable#reset()
     */
    @Override
    public void reset() {
        // nothing to do
    }

}
