/*
 * Project:  P-UMLaut
 * Filename: EntryStatus.java
 * Created:  10.06.2005
 * Author:   Tim Strazny
 */
package petruchio.sim.petrinettool.status;

import petruchio.sim.petrinettool.IPlaceStatus;

/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public final class Entry implements IPlaceStatus {

    public static final Entry ENTRY = new Entry();
    
    private Entry() { /* empty but private */ }
    
    public Entry getInstance() {
        return Entry.ENTRY;
    }
    
    
    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getName()
     */
    public String getName() {
        return "Entry";
    }


    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getPNML()
     */
    public String getPNML() {
        return "entry";
    }


    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getPEP()
     */
    public String getPEP() {
        return "e";
    }
    
    
    public boolean equals(final Object o) {
        return (o != null) && (o instanceof Entry);
    }


    public String toString() {
        return this.getName();
    }

}
