/*
 * Project:  P-UMLaut
 * Filename: ExitStatus.java
 * Created:  10.06.2005
 * Author:   Tim Strazny
 */
package petruchio.sim.petrinettool.status;

import petruchio.sim.petrinettool.IPlaceStatus;


/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public final class Exit implements IPlaceStatus {

    public static final Exit EXIT = new Exit();
    
    private Exit() { /* empty but private */ }
    
    public Exit getInstance() {
        return Exit.EXIT;
    }
    
    
    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getName()
     */
    public String getName() {
        return "Exit";
    }


    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getPNML()
     */
    public String getPNML() {
        return "exit";
    }


    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getPEP()
     */
    public String getPEP() {
        return "x";
    }
    
    
    public boolean equals(final Object o) {
        return (o != null) && (o instanceof Exit);
    }


    public String toString() {
        return this.getName();
    }

}
