/*
 * Project:  P-UMLaut
 * Filename: InternalStatus.java
 * Created:  10.06.2005
 * Author:   Tim Strazny
 */
package petruchio.sim.petrinettool.status;

import petruchio.sim.petrinettool.IPlaceStatus;


/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public final class Internal implements IPlaceStatus {

    public static final Internal INTERNAL = new Internal();
    
    private Internal() { /* empty but private */ }
    
    public Internal getInstance() {
        return Internal.INTERNAL;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getName()
     */
    public String getName() {
        return "Internal";
    }


    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getPNML()
     */
    public String getPNML() {
        return "internal";
    }


    /*
     * (non-Javadoc)
     * 
     * @see petruchio.sim.petrinettool.PlaceStatus#getPEP()
     */
    public String getPEP() {
        return "";
    }
    
    
    public boolean equals(final Object o) {
        return (o != null) && (o instanceof Internal);
    }


    public String toString() {
        return this.getName();
    }

}
