/*
 * Project:  P-UMLaut
 * Filename: Any.java
 * Created:  15.11.2005
 * Author:   Tim Strazny
 */
package petruchio.sim.petrinettool.type;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import petruchio.sim.petrinettool.IPlaceType;


public class Any implements IPlaceType {
    
    public static final IPlaceType ANY = new Any();
    
    public static final String STRING_ANY = "*";
    
    private final Collection<String> values;

    private Any() {
        final Collection<String> temp = new ArrayList<String>();
        temp.add(Any.STRING_ANY);
        this.values = Collections.unmodifiableCollection(temp);
    }

    
    public Collection<String> getValues() {
        return this.values;
    }
    
    
    public String getName() {
        return "Any";
    }
    
    
    public String getPNML() {
        return "<any />\n";
    }
    
    
    public String getPEP() {
        return Any.STRING_ANY;
    }
    
    
    public String toString() {
        return this.getName();
    }
    
    
    public boolean equals(final Object o) {
        return (o != null) && (o instanceof Any);
    }

    
    public boolean isValue(final String theValue) {
        return true;
    }
    
    
    public String getRandomValue() {
        return Any.STRING_ANY;
    }
}

