/*
 * Project:  pg
 * Filename: BlackToken.java
 * Created:  Jun 9, 2005
 * Author:   Tim Strazny
 */
package petruchio.sim.petrinettool.type;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import petruchio.sim.petrinettool.IPlaceType;

/**
 * TODO: document
 *
 * @author Tim Strazny
 */
public final class BlackToken implements IPlaceType {
    
    public static final BlackToken BLACK_TOKEN = new BlackToken();
    
    public static final Collection<String> VALUES;
    
    static {
        final Collection<String> temp = new ArrayList<String>();
        temp.add("dot");
        VALUES = Collections.unmodifiableCollection(temp);
    }
    
    private BlackToken() { /* empty but private */ }
    
    public BlackToken getInstance() {
        return BlackToken.BLACK_TOKEN;
    }
    
    
    public Collection<String> getValues() {
        return BlackToken.VALUES;
    }
    
    
    public String getName() {
        return "BlackToken";
    }
    
    
    public String getPNML() {
        return "<symbol>dot</symbol>\n";
    }
    
    
    public String getPEP() {
        return "dot";
    }
    
    
    public String toString() {
        return this.getName();
    }
    
    
    public boolean equals(final Object o) {
        return (o != null) && (o instanceof BlackToken);
    }

    
    public boolean isValue(final String value) {
        return value.equals("dot");
    }
    
    
    public String getRandomValue() {
        return "dot";
    }
}
