/*
 * Project:  pg
 * Filename: SingleValueType.java
 * Created:  Jul 20, 2005
 * Author:   Tim Strazny
 */
package petruchio.sim.petrinettool.type;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import petruchio.sim.petrinettool.IPlaceType;


/**
 * TODO: document
 *
 * @author Tim Strazny
 */
public class SingleValue implements IPlaceType {
    
    private final String value;
    
    private final Collection<String> values;

    public SingleValue(String value) {
        if(value == null) {
            throw new IllegalArgumentException("Value may not be null");
        }
        this.value = value;
        final Collection<String> temp = new ArrayList<String>();
        temp.add(value);
        this.values = Collections.unmodifiableCollection(temp);
    }

    
    public Collection<String> getValues() {
        return this.values;
    }
    
    
    public String getValue() {
        return this.value;
    }
    
    
    public String getName() {
        return "Value(" + this.value + ")";
    }
    
    
    public String getPNML() {
        return "<value>" + this.value + "</value>\n";
    }
    
    
    public String getPEP() {
        return this.value;
    }
    
    
    public String toString() {
        return this.getName();
    }
    
    
    public boolean equals(final Object o) {
        return (o instanceof SingleValue) && this.equals((SingleValue)o);
    }
    
    
    public boolean equals(final SingleValue o) {
        return (o == this) || ((o != null) && this.getValue().equals(o.getValue()));
    }
    
    public boolean isValue(final String theValue) {
        return this.value.equals(theValue);
    }
    
    
    public String getRandomValue() {
        return this.value;
    }
}
