/*
 * Project:  P-UMLaut
 * Filename: ExpressionType.java
 * Created:  21.05.2006
 * Author:   Tim Strazny
 */
package petruchio.sim.pnmodel.net;

import petruchio.sim.pnmodel.util.Node;
import petruchio.sim.pnmodel.util.TreeComputer;


public enum ExpressionType {
    GUARD("guard", "tt"),
    PRIORITY("priority", "0"),
    EARLIEST_FIRING("earliest", "0"),
    LATEST_FIRING("latest", "inf"),
    RATE("rate", ""),
    WEIGHT("weight", ""),
    GENERALIZED_RATE("generalized_rate", ""),
    GENERALIZED_WEIGHT("generalized_weight", ""),
    AGE_MEMORY("age", "ff"),
    SERVERS("servers", "1");
    
    private final Node defaultTree;
    private final String name;
    
    private ExpressionType(final String name, final String defaultExpression) {
        if(defaultExpression == null) {
            throw new IllegalArgumentException("The expression may not be null.");
        }
        this.defaultTree = TreeComputer.infixToTree(defaultExpression);
        this.name = name;
    }
    
    
    @Override
    public String toString() {
        return this.name;
    }
    
    
//    private ExpressionType(final Node defaultTree) {
//        if(defaultTree == null) {
//            throw new IllegalArgumentException("The syntax tree may not be null.");
//        }
//        this.defaultTree = defaultTree;
//    }
    
    
    public Node defaultTree() {
        return this.defaultTree;
    }
}
