/*
 * Project:  UML2PN
 * Filename: SynchronizationTask.java
 * Created:  Apr 26, 2005
 * Author:   Tim Strazny
 */
package petruchio.sim.pnmodel.net;


/**
 * <Description>
 * 
 * @author Tim Strazny
 */
public class SynchronizationTask {

    private final Transition transitionA;

    private final Transition transitionB;

    private final Action actionA;

    private final Action actionB;


    public SynchronizationTask(final Transition tA, final Action aA,
                    final Transition tB, final Action aB) {
        this.transitionA = tA;
        this.actionA = aA;
        this.transitionB = tB;
        this.actionB = aB;
    }


    /**
     * @return Returns the actionA.
     */
    public Action getActionA() {
        return this.actionA;
    }


    /**
     * @return Returns the actionB.
     */
    public Action getActionB() {
        return this.actionB;
    }


    /**
     * @return Returns the transitionA.
     */
    public Transition getTransitionA() {
        return this.transitionA;
    }


    /**
     * @return Returns the transitionB.
     */
    public Transition getTransitionB() {
        return this.transitionB;
    }
    
    public String toString() {
        return this.transitionA + "\n" + this.actionA + "\n\n"
                    + this.transitionB + "\n" + this.actionB + "\n\n"; 
    }
}