/*
 * Project:  PG-UML
 * Filename: Layouter.java
 * Created:  06.06.2005
 * Author:   Tim Strazny
 */
package petruchio.sim.pnmodel.util;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;

import petruchio.sim.pnmodel.net.PetriNet;

import petruchio.sim.petrinettool.IPlace;
import petruchio.sim.petrinettool.ITransition;


/**
 * <Description>
 * 
 * @author Tim Strazny
 */
@SuppressWarnings("unchecked")
public class GridLayouter implements Layouter {
    public void layout(PetriNet net) {
        ArrayList places = new ArrayList();
        ArrayList transitions = new ArrayList();

        int xVal = 200;
        int yVal = 50;
        int xOff = 100;
        int yOff = 100;

        //int lastChildOff = 0;//TODO: Find a nicer algorithm
        //int nextChildOff = 0;
        
        boolean isPlace = true;

        IPlace[] entries = net.getEntryPlaces();
        ArrayList actualElements = new ArrayList();

        actualElements.addAll(Arrays.asList(entries));

        while (!actualElements.isEmpty()) {
            ArrayList nextElements = new ArrayList();
            Iterator actElemIter = actualElements.iterator();
            while (actElemIter.hasNext()) {
                if (isPlace) {
                    petruchio.sim.pnmodel.net.Place actPlace = (petruchio.sim.pnmodel.net.Place) actElemIter.next();
                    if (!places.contains(actPlace.getName())) {
                        places.add(actPlace.getName());
                        actPlace.setPos(xVal, yVal);
                        ITransition[] actChildren = actPlace
                                .getSuccessorTransitions();
                        nextElements.addAll(Arrays.asList(actChildren));
                    } else {
                        continue;
                    }
                } else {
                    petruchio.sim.pnmodel.net.Transition actTrans = (petruchio.sim.pnmodel.net.Transition) actElemIter
                            .next();
                    if (!transitions.contains(actTrans.getName())) {
                        transitions.add(actTrans.getName());
                        actTrans.setPos(xVal, yVal);
                        IPlace[] actChildren = actTrans.getSuccessorPlaces();
                        nextElements.addAll(Arrays.asList(actChildren));
                    } else {
                        continue;
                    }
                }
                xVal+=xOff;

            }
            isPlace = !isPlace;
            yVal += yOff;
            xVal = 200;
            actualElements = nextElements;
        }
    }
}
