/*
 * Project:  P-UMLaut
 * Filename: Pool.java
 * Created:  13.08.2005
 * Author:   Tim Strazny
 */
package petruchio.sim.pnmodel.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import petruchio.sim.pnmodel.net.Value;
import petruchio.sim.pnmodel.net.ValueList;

public class Pool {
    private static Pool pool = new Pool();
    
    public synchronized static Pool getPool() {
        return pool;
    }
    
    
    public <T> List<T> getList(final Collection<T> col) {
        return new ArrayList<T>(col);
    }
    
    
    public <T> List<T> getList() {
        return new ArrayList<T>();
    }
    
       
    public ValueList getValueList(final Collection<? extends Value> col) {
        return new ValueList(col);
    }
    
    
    public ValueList getValueList() {
        return new ValueList();
    }
    
    
    public <A, B> Map<A, B> getMap() {
        return new HashMap<A, B>();
    }
    
    
    public <A, B> Map<A, B> getMap(final Map<? extends A, ? extends B> map) {
        return new HashMap<A, B>(map);
    }
    
    
    public Binding getBinding() {
        return new Binding();
    }
    
}
