/*
 * Project:  P-UMLaut
 * Filename: Values.java
 * Created:  29.07.2005
 * Author:   Tim Strazny
 */
package petruchio.sim.pnmodel.util;

import java.util.Map;
import java.util.Collection;

import petruchio.sim.petrinettool.IPlace;
import petruchio.sim.petrinettool.IPlaceType;
import petruchio.sim.pnmodel.net.Value;
import petruchio.sim.pnmodel.net.ValueList;

public class Values {
    private final static Map<IPlaceType, ValueList> theMap = new FastHashMap<IPlaceType, ValueList>();
    
    public static ValueList getValues(final IPlaceType type) {
        synchronized(Values.theMap) {
            ValueList col = Values.theMap.get(type);
            if(col == null) {
                col = Values.parseValues(type.getValues());
                Values.theMap.put(type, col);
            }
            return col;
        }
    }
    
    public static ValueList parseValues(final Collection<String> values) {
        final ValueList col = Pool.getPool().getValueList();
        for(final String value : values) {
            if(value.length() > 0) {
                if(value.equals(IPlace.STRING_ANY)) {
                    if(!col.contains(Value.V_ANY)) {
                        col.add(Value.V_ANY);
                    }
                } else {
                    Value val = Value.getValue(value);
                    if(!col.contains(val)) {
                        col.add(val);
                    }
                }
            }
        }
        return col;
    }
}
